#include "device.h"
#include "num_conv.h"
#include "parser_1.h"
#include <stdio.h>

/* stampa i simboli */
static void printsy(symbol s) {
	switch(s) {
		case PLUS:	puts("PLUS");			break;
		case MINUS:	puts("MINUS");			break;
		case TIMES:	puts("TIMES");			break;
		case DIVSY:	puts("DIVSY");			break;
		case MODSY:	puts("MODSY");			break;
		case VARSY:	puts("VARSY");			break;
		case BECOMES:	puts("BECOMES");		break;
		case COLON:	puts("COLON");			break;
		case SEMICOLON:	puts("SEMICOLON");		break;
		case FULLSTOP:	puts("FULLSTOP");		break;
		case RPAR:	puts("RPAR");			break;
		case LPAR:	puts("LPAR");			break;
		case FINE:	puts("FINE");			break;
		case ERRSY:	puts("ERRSY");			break;
		default:
			puts("**Error (print): simbolo non riconosciuto");
			break;
	}
}

/* stampa il dato contenuto nel nodo */
static void printnodeval(tree t) {
	switch(t->tag) {
		case CST:;
			printf("%d\n", t->U.val);
			break;

		case VRB:
			printf("%s\n", t->U.stringaid);
			break;

		case OPR:
			printsy(t->U.opcode);
			break;
	}
}

/* stampa indendata dell'albero */
static void printtree(int displace, tree t) {
	int i;

	if(!empty(t)) {
		if(t->sin==NULL && t->des==NULL) {
			for(i=0; i<displace; i++)
				printf("\t");

			printnodeval(t);
		}
		else {
			printtree(displace+1, right(t));
			for(i=0; i<displace; i++)
				printf("\t");
			printnodeval(t);
			printtree(displace+1, left(t));
		}
	}
	else
		puts("** Error: l'albero  vuoto, c' qualcosa che tragia nel sorgente");
}

int main() {
	if(!initdevice(SOURCE_FILE)) {
		setbase(BASE);
		puts("-- Test Parser_1 --");
		printtree(0, program());
	}
	return 0;
}
