; --- INIZIO FILE ASSMBLER ---

; debug attivato

; data: dati inizializzati
segment .data
	int_format	db	"%d",0	; terminatore NULL del C
	string_format	db	"%s",0
	header		db	"-- Valore finale delle Variabili --",0
	variabile	db	"Variabile: ",0
	valore		db	"Valore: ",0
	notused		db	"Non utilizzata",0
	overflow_msg	db	"** Error: int overflow!",0
	divide_zero	db	"** Error: divide by zero!",0
	var_A		db	"A",0
	var_B		db	"B",0
	var_C		db	"C",0

; bss: dati non inizializzati
segment .bss
	A		resd	1
	B		resd	1
	C		resd	1

; text: codice
section .text
	global asm_main		; esporto la routine asm_main
	extern printf, putchar	; funzioni definite altrove (lib c)

asm_main:
	enter 0,0		; routine di setup
	pusha			; push di tutti i registri

; ------ fine prologo ------

; valpush
	mov	eax, 1
	push	eax

; varpop: "A"
	pop	eax
	mov	[A], eax

; varpush: "A"
	mov	eax, [A]
	push	eax

; valpush
	mov	eax, 10
	push	eax

; moltiplicazione
	pop	ebx
	pop	eax
	imul	ebx
	jo near	overflow_label
	push	eax

; varpush: "A"
	mov	eax, [A]
	push	eax

; somma
	pop	ebx
	pop	eax
	add	eax, ebx
	jo near	overflow_label	; se si verifica un overflow
	push	eax

; varpop: "B"
	pop	eax
	mov	[B], eax

; varpush: "B"
	mov	eax, [B]
	push	eax

; valpush
	mov	eax, 1
	push	eax

; somma
	pop	ebx
	pop	eax
	add	eax, ebx
	jo near	overflow_label	; se si verifica un overflow
	push	eax

; varpop: "A"
	pop	eax
	mov	[A], eax

; varpush: "A"
	mov	eax, [A]
	push	eax

; varpush: "A"
	mov	eax, [A]
	push	eax

; divisione
	pop	ebx
	cmp	ebx, 0
	je near	divide_label
	pop	eax
	cdq
	idiv	ebx
	push	eax

; varpop: "B"
	pop	eax
	mov	[B], eax

; ------ inizio epilogo ------

; stampo l'header
	mov eax, header		; metto in eax l'indirizzo della stringa
	call print_string	; chiamo routine stampa
	call print_nl		; stampa un carattere new line

; stampo la variabile A e il suo valore
	mov eax, variabile
	call print_string
	mov eax, var_A
	call print_string
	call print_tab
	mov eax, valore
	call print_string
	mov eax, [A]
	call print_int
	call print_nl
; stampo la variabile B e il suo valore
	mov eax, variabile
	call print_string
	mov eax, var_B
	call print_string
	call print_tab
	mov eax, valore
	call print_string
	mov eax, [B]
	call print_int
	call print_nl
; stampo la variabile C e il suo valore
	mov eax, variabile
	call print_string
	mov eax, var_C
	call print_string
	call print_tab
	mov eax, notused
	call print_string
	call print_nl
	popa
	mov eax, 0		; ritorna al codice C
	leave
	ret

; stampa un intero
print_int:
	enter 0,0
	pusha
	pushf

	push eax
	push dword int_format
	call printf
	pop ecx
	pop ecx

	popf
	popa
	leave
	ret

; stampa una stringa
print_string:
	enter 0,0
	pusha
	pushf

	push eax
	push dword string_format
	call printf
	pop ecx
	pop ecx

	popf
	popa
	leave
	ret

; stampa un carattere di newline
print_nl:
	enter 0,0
	pusha
	pushf

	push eax
	push dword 10		; 10 == ASCII \n
	call putchar
	pop ecx
	pop ecx

	popf
	popa
	leave
	ret

; stampa un carattere di tabulazione
print_tab:
	enter 0,0
	pusha
	pushf

	push eax
	push dword 9		; 9 == ASCII \t
	call putchar
	pop ecx
	pop ecx

	popf
	popa
	leave
	ret

; stampa un errore e torna al chimante
overflow_label:
	mov eax, overflow_msg	; stampa l'errore
	call print_string
	call print_nl		; stampa un carattere new line

	popa
	mov eax, 1		; ritorna al codice C

	leave
	ret

; stampa un errore e torna al chimante
divide_label:
	mov eax, divide_zero	; stampa l'errore
	call print_string
	call print_nl		; stampa un carattere new line

	popa
	mov eax, 1		; ritorna al codice C

	leave
	ret

; --- FINE FILE ASSMBLER ---
